/***************************************************************************
 * Copyright 2014 Kieker Project (http://kieker-monitoring.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/

package mooBench.monitoredApplication;

/**
 * @author Jan Waller
 */
public final class MonitoredClassSimple implements MonitoredClass {

	/**
	 * Default constructor.
	 */
	public MonitoredClassSimple() {
		// empty default constructor
	}

	public final long monitoredMethod(final long methodTime, final int recDepth) {
		if (recDepth > 1) {
			return this.monitoredMethod(methodTime, recDepth - 1);
		} else {
			final long exitTime = System.nanoTime() + methodTime;
			long currentTime;
			do {
				currentTime = System.nanoTime();
			} while (currentTime < exitTime);
			return currentTime;
		}
	}
}
